*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/if_isaedreg.h
***************
*** 0 ****
--- 1,398 ----
+ /*	$NetBSD: if_isaedreg.h,v 1.12 1994/10/27 04:17:23 cgd Exp $	*/
+ 
+ /*
+  * National Semiconductor DS8390 NIC register definitions.
+  *
+  * Copyright (C) 1993, David Greenman.  This software may be used, modified,
+  * copied, distributed, and sold, in both source and binary form provided that
+  * the above copyright and these terms are retained.  Under no circumstances is
+  * the author responsible for the proper functioning of this software, nor does
+  * the author assume any responsibility for damages incurred with its use.
+  */
+ 
+ /*
+  * Vendor types
+  */
+ #define ED_VENDOR_WD_SMC	0x00	/* Western Digital/SMC */
+ #define ED_VENDOR_3COM		0x01	/* 3Com */
+ #define ED_VENDOR_NOVELL	0x02	/* Novell */
+ 
+ /*
+  * Compile-time config flags
+  */
+ /*
+  * This sets the default for enabling/disablng the tranceiver.
+  */
+ #define ED_FLAGS_DISABLE_TRANCEIVER	0x0001
+ 
+ /*
+  * This forces the board to be used in 8/16-bit mode even if it autoconfigs
+  * differently.
+  */
+ #define ED_FLAGS_FORCE_8BIT_MODE	0x0002
+ #define ED_FLAGS_FORCE_16BIT_MODE	0x0004
+ 
+ /*
+  * This disables the use of double transmit buffers.
+  */
+ #define ED_FLAGS_NO_MULTI_BUFFERING	0x0008
+ 
+ /*
+  * This forces all operations with the NIC memory to use Programmed I/O (i.e.
+  * not via shared memory).
+  */
+ #define ED_FLAGS_FORCE_PIO		0x0010
+ 
+ /*
+  *		Definitions for Western digital/SMC WD80x3 series ASIC
+  */
+ /*
+  * Memory Select Register (MSR)
+  */
+ #define ED_WD_MSR	0
+ 
+ /* next three definitions for Toshiba */
+ #define	ED_WD_MSR_POW	0x02	/* 0 = power save, 1 = normal (R/W) */
+ #define	ED_WD_MSR_BSY	0x04	/* gate array busy (R) */
+ #define	ED_WD_MSR_LEN	0x20	/* 0 = 16-bit, 1 = 8-bit (R/W) */
+ 
+ #define ED_WD_MSR_ADDR	0x3f	/* Memory decode bits 18-13 */
+ #define ED_WD_MSR_MENB	0x40	/* Memory enable */
+ #define ED_WD_MSR_RST	0x80	/* Reset board */
+ 
+ /*
+  * Interface Configuration Register (ICR)
+  */
+ #define ED_WD_ICR	1
+ 
+ #define ED_WD_ICR_16BIT	0x01	/* 16-bit interface */
+ #define ED_WD_ICR_OAR	0x02	/* select register (0=BIO 1=EAR) */
+ #define ED_WD_ICR_IR2	0x04	/* high order bit of encoded IRQ */
+ #define ED_WD_ICR_MSZ	0x08	/* memory size (0=8k 1=32k) */
+ #define ED_WD_ICR_RLA	0x10	/* recall LAN address */
+ #define ED_WD_ICR_RX7	0x20	/* recall all but i/o and LAN address */
+ #define	ED_WD_ICR_RIO	0x40	/* recall i/o address */
+ #define ED_WD_ICR_STO	0x80	/* store to non-volatile memory */
+ #ifdef TOSH_ETHER
+ #define	ED_WD_ICR_MEM	0xe0	/* shared mem address A15-A13 (R/W) */
+ #define	ED_WD_ICR_MSZ1	0x0f	/* memory size, 0x08 = 64K, 0x04 = 32K,
+ 				   0x02 = 16K, 0x01 = 8K */
+ 				/* 64K can only be used if mem address
+ 				   above 1MB */
+ 				/* IAR holds address A23-A16 (R/W) */
+ #endif
+ 
+ /*
+  * IO Address Register (IAR)
+  */
+ #define ED_WD_IAR	2
+ 
+ /*
+  * EEROM Address Register
+  */
+ #define ED_WD_EAR	3
+ 
+ /*
+  * Interrupt Request Register (IRR)
+  */
+ #define ED_WD_IRR	4
+ 
+ #define	ED_WD_IRR_0WS	0x01	/* use 0 wait-states on 8 bit bus */
+ #define ED_WD_IRR_OUT1	0x02	/* WD83C584 pin 1 output */
+ #define ED_WD_IRR_OUT2	0x04	/* WD83C584 pin 2 output */
+ #define ED_WD_IRR_OUT3	0x08	/* WD83C584 pin 3 output */
+ #define ED_WD_IRR_FLASH	0x10	/* Flash RAM is in the ROM socket */
+ 
+ /*
+  * The three bits of the encoded IRQ are decoded as follows:
+  *
+  * IR2 IR1 IR0  IRQ
+  *  0   0   0   2/9
+  *  0   0   1   3
+  *  0   1   0   5
+  *  0   1   1   7
+  *  1   0   0   10
+  *  1   0   1   11
+  *  1   1   0   15
+  *  1   1   1   4
+  */
+ #define ED_WD_IRR_IR0	0x20	/* bit 0 of encoded IRQ */
+ #define ED_WD_IRR_IR1	0x40	/* bit 1 of encoded IRQ */
+ #define ED_WD_IRR_IEN	0x80	/* Interrupt enable */
+ 
+ /*
+  * LA Address Register (LAAR)
+  */
+ #define ED_WD_LAAR	5
+ 
+ #define ED_WD_LAAR_ADDRHI	0x1f	/* bits 23-19 of RAM address */
+ #define ED_WD_LAAR_0WS16	0x20	/* enable 0 wait-states on 16 bit bus */
+ #define ED_WD_LAAR_L16EN	0x40	/* enable 16-bit operation */
+ #define ED_WD_LAAR_M16EN	0x80	/* enable 16-bit memory access */
+ 
+ /* i/o base offset to station address/card-ID PROM */
+ #define ED_WD_PROM	8
+ 
+ /*
+  *	83C790 specific registers
+  */
+ /*
+  * Hardware Support Register (HWR) ('790)
+  */
+ #define	ED_WD790_HWR	4
+ 
+ #define	ED_WD790_HWR_RST	0x10	/* hardware reset */
+ #define	ED_WD790_HWR_LPRM	0x40	/* LAN PROM select */
+ #define	ED_WD790_HWR_SWH	0x80	/* switch register set */
+ 
+ /*
+  * ICR790 Interrupt Control Register for the 83C790
+  */
+ #define	ED_WD790_ICR	6
+ 
+ #define	ED_WD790_ICR_EIL	0x01	/* enable interrupts */
+ 
+ /*
+  * General Control Register (GCR)
+  * Eanbled with SWH bit == 1 in HWR register
+  */
+ #define	ED_WD790_GCR	0x0d
+ 
+ #define	ED_WD790_GCR_IR0	0x04	/* bit 0 of encoded IRQ */
+ #define	ED_WD790_GCR_IR1	0x08	/* bit 1 of encoded IRQ */
+ #define	ED_WD790_GCR_ZWSEN	0x20	/* zero wait state enable */
+ #define	ED_WD790_GCR_IR2	0x40	/* bit 2 of encoded IRQ */
+ /*
+  * The three bits of the encoded IRQ are decoded as follows:
+  *
+  * IR2 IR1 IR0  IRQ
+  *  0   0   0   none
+  *  0   0   1   9
+  *  0   1   0   3
+  *  0   1   1   5
+  *  1   0   0   7
+  *  1   0   1   10
+  *  1   1   0   11
+  *  1   1   1   15
+  */
+ 
+ /* i/o base offset to CARD ID */
+ #define ED_WD_CARD_ID	ED_WD_PROM+6
+ 
+ /* Board type codes in card ID */
+ #define ED_TYPE_WD8003S		0x02
+ #define ED_TYPE_WD8003E		0x03
+ #define ED_TYPE_WD8013EBT	0x05
+ #define	ED_TYPE_TOSHIBA1	0x11	/* named PCETA1 */
+ #define	ED_TYPE_TOSHIBA2	0x12	/* named PCETA2 */
+ #define	ED_TYPE_TOSHIBA3	0x13	/* named PCETB */
+ #define	ED_TYPE_TOSHIBA4	0x14	/* named PCETC */
+ #define	ED_TYPE_WD8003W		0x24
+ #define	ED_TYPE_WD8003EB	0x25
+ #define	ED_TYPE_WD8013W		0x26
+ #define ED_TYPE_WD8013EP	0x27
+ #define ED_TYPE_WD8013WC	0x28
+ #define ED_TYPE_WD8013EPC	0x29
+ #define	ED_TYPE_SMC8216T	0x2a
+ #define	ED_TYPE_SMC8216C	0x2b
+ #define ED_TYPE_WD8013EBP	0x2c
+ 
+ /* Bit definitions in card ID */
+ #define	ED_WD_REV_MASK		0x1f	/* Revision mask */
+ #define	ED_WD_SOFTCONFIG	0x20	/* Soft config */
+ #define	ED_WD_LARGERAM		0x40	/* Large RAM */
+ #define	ED_MICROCHANEL		0x80	/* Microchannel bus (vs. isa) */
+ 
+ /*
+  * Checksum total.  All 8 bytes in station address PROM will add up to this.
+  */
+ #ifdef TOSH_ETHER
+ #define ED_WD_ROM_CHECKSUM_TOTAL	0xA5
+ #else
+ #define ED_WD_ROM_CHECKSUM_TOTAL	0xFF
+ #endif
+ 
+ #define ED_WD_NIC_OFFSET	0x10	/* I/O base offset to NIC */
+ #define ED_WD_ASIC_OFFSET	0	/* I/O base offset to ASIC */
+ #define ED_WD_IO_PORTS		32	/* # of i/o addresses used */
+ 
+ #define ED_WD_PAGE_OFFSET	0	/* page offset for NIC access to mem */
+ 
+ /*
+  *			Definitions for 3Com 3c503
+  */
+ #define ED_3COM_NIC_OFFSET	0
+ #define ED_3COM_ASIC_OFFSET	0x400	/* offset to nic i/o regs */
+ 
+ /*
+  * XXX - The I/O address range is fragmented in the 3c503; this is the
+  *	number of regs at iobase.
+  */
+ #define ED_3COM_IO_PORTS	16	/* # of i/o addresses used */
+ 
+ /* tx memory starts in second bank on 8bit cards */
+ #define ED_3COM_TX_PAGE_OFFSET_8BIT	0x20
+ 
+ /* tx memory starts in first bank on 16bit cards */
+ #define ED_3COM_TX_PAGE_OFFSET_16BIT	0x0
+ 
+ /* ...and rx memory starts in second bank */
+ #define ED_3COM_RX_PAGE_OFFSET_16BIT	0x20
+ 
+ 
+ /*
+  * Page Start Register.  Must match PSTART in NIC.
+  */
+ #define ED_3COM_PSTR		0
+ 
+ /*
+  * Page Stop Register.  Must match PSTOP in NIC.
+  */
+ #define ED_3COM_PSPR		1
+ 
+ /*
+  * DrQ Timer Register.  Determines number of bytes to be transfered during a
+  * DMA burst.
+  */
+ #define ED_3COM_DQTR		2
+ 
+ /*
+  * Base Configuration Register.  Read-only register which contains the
+  * board-configured I/O base address of the adapter.  Bit encoded.
+  */
+ #define ED_3COM_BCFR		3
+ 
+ /*
+  * EPROM Configuration Register.  Read-only register which contains the
+  * board-configured memory base address.  Bit encoded.
+  */
+ #define ED_3COM_PCFR		4
+ 
+ /*
+  * GA Configuration Register.  Gate-Array Configuration Register.
+  *
+  * mbs2  mbs1  mbs0	start address
+  *  0     0     0	0x0000
+  *  0     0     1	0x2000
+  *  0     1     0	0x4000
+  *  0     1     1	0x6000
+  *
+  * Note that with adapters with only 8K, the setting for 0x2000 must always be
+  * used.
+  */
+ #define ED_3COM_GACFR		5
+ 
+ #define ED_3COM_GACFR_MBS0	0x01
+ #define ED_3COM_GACFR_MBS1	0x02
+ #define ED_3COM_GACFR_MBS2	0x04
+ 
+ #define ED_3COM_GACFR_RSEL	0x08	/* enable shared memory */
+ #define ED_3COM_GACFR_TEST	0x10	/* for GA testing */
+ #define ED_3COM_GACFR_OWS	0x20	/* select 0WS access to GA */
+ #define ED_3COM_GACFR_TCM	0x40	/* Mask DMA interrupts */
+ #define ED_3COM_GACFR_NIM	0x80	/* Mask NIC interrupts */
+ 
+ /*
+  * Control Register.  Miscellaneous control functions.
+  */
+ #define ED_3COM_CR		6
+ 
+ #define ED_3COM_CR_RST		0x01	/* Reset GA and NIC */
+ #define ED_3COM_CR_XSEL		0x02	/* Transceiver select.  BNC=1(def) AUI=0 */
+ #define ED_3COM_CR_EALO		0x04	/* window EA PROM 0-15 to I/O base */
+ #define ED_3COM_CR_EAHI		0x08	/* window EA PROM 16-31 to I/O base */
+ #define ED_3COM_CR_SHARE	0x10	/* select interrupt sharing option */
+ #define ED_3COM_CR_DBSEL	0x20	/* Double buffer select */
+ #define ED_3COM_CR_DDIR		0x40	/* DMA direction select */
+ #define ED_3COM_CR_START	0x80	/* Start DMA controller */
+ 
+ /*
+  * Status Register.  Miscellaneous status information.
+  */
+ #define ED_3COM_STREG		7
+ 
+ #define ED_3COM_STREG_REV	0x07	/* GA revision */
+ #define ED_3COM_STREG_DIP	0x08	/* DMA in progress */
+ #define ED_3COM_STREG_DTC	0x10	/* DMA terminal count */
+ #define ED_3COM_STREG_OFLW	0x20	/* Overflow */
+ #define ED_3COM_STREG_UFLW	0x40	/* Underflow */
+ #define ED_3COM_STREG_DPRDY	0x80	/* Data port ready */
+ 
+ /*
+  * Interrupt/DMA Configuration Register
+  */
+ #define ED_3COM_IDCFR		8
+ 
+ #define ED_3COM_IDCFR_DRQ	0x07	/* DMA request */
+ #define ED_3COM_IDCFR_UNUSED	0x08	/* not used */
+ #if 0
+ #define ED_3COM_IDCFR_IRQ	0xF0	/* Interrupt request */
+ #else
+ #define ED_3COM_IDCFR_IRQ2	0x10	/* Interrupt request 2 select */
+ #define ED_3COM_IDCFR_IRQ3	0x20	/* Interrupt request 3 select */
+ #define ED_3COM_IDCFR_IRQ4	0x40	/* Interrupt request 4 select */
+ #define ED_3COM_IDCFR_IRQ5	0x80	/* Interrupt request 5 select */
+ #endif
+ 
+ /*
+  * DMA Address Register MSB
+  */
+ #define ED_3COM_DAMSB		9
+ 
+ /*
+  * DMA Address Register LSB
+  */
+ #define ED_3COM_DALSB		0x0a
+ 
+ /*
+  * Vector Pointer Register 2
+  */
+ #define ED_3COM_VPTR2		0x0b
+ 
+ /*
+  * Vector Pointer Register 1
+  */
+ #define ED_3COM_VPTR1		0x0c
+ 
+ /*
+  * Vector Pointer Register 0
+  */
+ #define ED_3COM_VPTR0		0x0d
+ 
+ /*
+  * Register File Access MSB
+  */
+ #define ED_3COM_RFMSB		0x0e
+ 
+ /*
+  * Register File Access LSB
+  */
+ #define ED_3COM_RFLSB		0x0f
+ 
+ /*
+  *		 Definitions for Novell NE1000/2000 boards
+  */
+ 
+ /*
+  * Board type codes
+  */
+ #define ED_TYPE_NE1000		0x01
+ #define ED_TYPE_NE2000		0x02
+ 
+ /*
+  * Register offsets/total
+  */
+ #define ED_NOVELL_NIC_OFFSET	0x00
+ #define ED_NOVELL_ASIC_OFFSET	0x10
+ #define ED_NOVELL_IO_PORTS	32
+ 
+ /*
+  * Remote DMA data register; for reading or writing to the NIC mem via
+  * programmed I/O (offset from ASIC base).
+  */
+ #define ED_NOVELL_DATA		0x00
+ 
+ /*
+  * Reset register; reading from this register causes a board reset.
+  */
+ #define ED_NOVELL_RESET		0x0f
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/isa_intr.h
***************
*** 0 ****
--- 1,58 ----
+ /*	$NetBSD: isa_intr.h,v 1.1 1995/08/02 14:44:57 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1995 Niklas Hallqvist.
+  * All rights reserved.
+  *
+  * Copyright (c) 1995 Carnegie-Mellon University.
+  * All rights reserved.
+  *
+  * Authors: Chris G. Demetriou, Niklas Hallqvist.
+  * 
+  * Permission to use, copy, modify and distribute this software and
+  * its documentation is hereby granted, provided that both the copyright
+  * notice and this permission notice appear in all copies of the
+  * software, derivative works or modified versions, and any portions
+  * thereof, and that both notices appear in supporting documentation.
+  * 
+  * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" 
+  * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND 
+  * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
+  * 
+  * Carnegie Mellon requests users of this software to return to
+  *
+  *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
+  *  School of Computer Science
+  *  Carnegie Mellon University
+  *  Pittsburgh PA 15213-3890
+  *
+  * any improvements or extensions that they make and grant Carnegie the
+  * rights to redistribute these changes.
+  */
+ 
+ /* Prototypes for ISA-ish I/O interrupt functions. */
+ 
+ /*
+  * XXX
+  * XXX THIS WILL LIKELY HAVE TO BE COMPLETELY CHANGED.
+  * XXX
+  */
+ 
+ struct	isa_intr_fcns {
+ 	void	(*isa_intr_setup) __P((void));
+ 
+ 	void	*(*isa_intr_establish) __P((int irq, isa_intrtype type,
+ 		    isa_intrlevel level, int (*ih_fun)(void *), void *ih_arg));
+ 	void	(*isa_intr_disestablish) __P((void *handler));
+ 
+ 	void	(*isa_iointr) __P((void *framep, int vec));
+ };
+ 
+ /*
+  * Global which tells which set of functions are correct
+  * for this machine.
+  */
+ struct	isa_intr_fcns *isa_intr_fcns;
+ 
+ extern struct isa_intr_fcns ggbus_intr_fcns;
+ extern struct isa_intr_fcns cross_intr_fcns;
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/isa_machdep.c
***************
*** 0 ****
--- 1,162 ----
+ /*	$NetBSD: isa_machdep.c,v 1.1 1995/08/02 14:10:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1995 Niklas Hallqvist
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Niklas Hallqvist.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #include <sys/param.h>
+ #include <sys/device.h>
+ #include <sys/malloc.h>
+ 
+ #include <dev/isa/isavar.h>
+ 
+ #include <machine/pio.h>
+ 
+ #include <amiga/amiga/device.h>
+ #include <amiga/isa/isa_intr.h>
+ 
+ void	isaattach __P((struct device *, struct device *, void *));
+ int	isamatch __P((struct device *, void *, void *));
+ 
+ /*
+  * After careful thought about this issue I decided that allowing only
+  * one isabus configured into a system would be sufficient.  I'm not
+  * lazy, I did the original design with possibilities of multiple ISA
+  * busses, but that made porting of existing drivers a bit harder and
+  * error-prone, as well as I had to write obfuscated code.  This
+  * solution is more in the spirit of KISS.  --niklas@appli.se
+  */
+ struct isa_link *isa;
+ int isadebug = 0;
+ 
+ struct cfdriver isacd = {
+ 	NULL, "isa", isamatch, isaattach,
+ 	DV_DULL, sizeof(struct device), 1
+ };
+ 
+ int
+ isamatch(parent, cfdata, aux)
+ 	struct device *parent;
+ 	void *cfdata, *aux;
+ {
+ 	struct cfdata *cf = cfdata;
+ 
+ #ifdef DEBUG
+ 	if (isadebug)
+ 		printf(" isamatch");
+ #endif
+ 
+ 	/* See if the unit number is valid. */
+ 	if (cf->cf_unit > 0)
+ 		return (0);
+ 
+ 	return (1);
+ }
+ 
+ void
+ isaattach(parent, self, aux)
+ 	struct device *parent, *self;
+ 	void *aux;
+ {
+ 	struct isa_softc *sc = (struct isa_softc *)self;
+ 
+ 	isa = (struct isa_link *)aux;
+ 
+ 	printf("\n");
+ 
+ 	TAILQ_INIT (&sc->sc_subdevs);
+ 
+ 	config_scan(isascan, self);
+ }
+ 
+ void *
+ isa_intr_establish(intr, type, level, ih_fun, ih_arg)
+ 	int intr;
+ 	isa_intrtype type;
+ 	isa_intrlevel level;
+ 	int (*ih_fun)(void *);
+ 	void *ih_arg;
+ {
+ 	return (*isa_intr_fcns->isa_intr_establish)(intr, type, level,
+ 	    ih_fun, ih_arg);
+ }
+ 
+ void
+ isa_intr_disestablish(handler)
+ 	void *handler;
+ {
+ 	(*isa_intr_fcns->isa_intr_disestablish)(handler);
+ }
+ 
+ void
+ isa_outsb(port, addr, cnt)
+ 	int port;
+ 	void *addr;
+ 	int cnt;
+ {
+ 	u_int8_t *p = addr;
+ 
+ 	while (cnt--)
+ 		outb(port, *p++);
+ }
+ 
+ void
+ isa_insb(port, addr, cnt)
+ 	int port;
+ 	void *addr;
+ 	int cnt;
+ {
+ 	u_int8_t *p = addr;
+ 
+ 	while (cnt--)
+ 		*p++ = inb(port);
+ }
+ 
+ void
+ isa_outsw(port, addr, cnt)
+ 	int port;
+ 	void *addr;
+ 	int cnt;
+ {
+ 	u_int16_t *p = addr;
+ 
+ 	while (cnt--)
+ 		outw(port, *p++);
+ }
+ 
+ void
+ isa_insw(port, addr, cnt)
+ 	int port;
+ 	void *addr;
+ 	int cnt;
+ {
+ 	u_int16_t *p = addr;
+ 
+ 	while (cnt--)
+ 		*p++ = inw(port);
+ }
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/isa_machdep.h
***************
*** 0 ****
--- 1,192 ----
+ /*	$NetBSD: isa_machdep.h,v 1.1 1995/07/21 23:07:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1995 Niklas Hallqvist
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Niklas Hallqvist.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #ifndef _ISA_MACHDEP_H_
+ #define _ISA_MACHDEP_H_
+ 
+ #include <machine/endian.h>
+ 
+ void	isa_insb __P((int port, void *addr, int));
+ void	isa_outsb __P((int port, void *addr, int));
+ void	isa_insw __P((int port, void *addr, int));
+ void	isa_outsw __P((int port, void *addr, int));
+ 
+ /*
+  * The link between the ISA device drivers and the bridgecard used.
+  */
+ struct isa_link {
+ 	struct	device *il_dev;
+ 	void	(*il_stb)(struct device *, int, u_char);
+ 	u_char	(*il_ldb)(struct device *, int);
+ 	void	(*il_stw)(struct device *, int, u_short);
+ 	u_short	(*il_ldw)(struct device *, int);
+ };
+ 
+ extern struct isa_link *isa;
+ extern struct cfdriver isacd;
+ 
+ static __inline void
+ stb(addr, val)
+ 	int addr;
+ 	u_char val;
+ {
+ 	(*isa->il_stb)(isa->il_dev, addr, val);
+ }
+ 
+ static __inline u_char
+ ldb(addr)
+ 	int addr;
+ {
+ 	return (*isa->il_ldb)(isa->il_dev, addr);
+ }
+ 
+ static __inline void
+ stw(addr, val)
+ 	int addr;
+ 	u_short val;
+ {
+ 	(*isa->il_stw)(isa->il_dev, addr, val);
+ }
+ 
+ static __inline u_short
+ ldw(addr)
+ 	int addr;
+ {
+ 	return (*isa->il_ldw)(isa->il_dev, addr);
+ }
+ 
+ /*
+  * Should these be out-of-line instead?  If so, move them to isa.c!
+  * How about unaligned word accesses?  Does the '020 allow them?  If not
+  * we have to do odd to even moves and vice versa bytewise instead of
+  * wordwise.
+  */
+ static __inline void
+ copy_from_isa (void *from, void *to, int cnt)
+ {
+ 	int a = (int)from;
+ 
+ 	if (a & 1 && cnt) {
+ 		*(u_char *)to = ldb(a++);
+ 		to = ((u_char *)to) + 1;
+ 		cnt--;
+ 	}
+ 	/* Maybe use Duff's device here... */
+ 	while (cnt > 1) {
+ 		*(u_short *)to = ldw(a);
+ 		a += sizeof(u_short);
+ 		to = ((u_short *)to) + 1;
+ 		cnt -= 2;
+ 	}
+ 	if (cnt)
+ 		*(u_char *)to = ldb(a);
+ }
+ 
+ static __inline void
+ copy_to_isa (const void *from, void *to, int cnt)
+ {
+ 	int a = (int)to;
+ 
+ 	if (a & 1 && cnt) {
+ 		stb(a++, *(u_char *)from);
+ 		from = ((u_char *)from) + 1;
+ 		cnt--;
+ 	}
+ 	/* Maybe use Duff's device here... */
+ 	while (cnt > 1) {
+ 		stw(a, *(u_short *)from);
+ 		a += sizeof(u_short);
+ 		from = ((u_short *)from) + 1;
+ 		cnt -= 2;
+ 	}
+ 	if (cnt)
+ 		stb(a, *(u_char *)from);
+ }
+ 
+ static __inline void
+ zero_isa (void *addr, int cnt)
+ {
+ 	int a = (int)addr;
+ 
+ 	if (a & 1 && cnt) {
+ 		stb(a++, 0);
+ 		cnt--;
+ 	}
+ 	/* Maybe use Duff's device here... */
+ 	while (cnt > 1) {
+ 		stw(a, 0);
+ 		a += sizeof(u_short);
+ 		cnt -= 2;
+ 	}
+ 	if (cnt)
+ 		stb(a, 0);
+ }
+ 
+ /*
+  * These inlines convert shorts from/to isa (intel) byte order to host
+  * byte-order.  I know both are exactly equal, but I think it make code
+  * more readable to have separate names for them as they indeed have
+  * distinctive functionalities.
+  */
+ static __inline u_short
+ swap(u_short x)
+ {
+ 	__asm("rolw #8,%0" : "=r" (x) : "0" (x));
+ 	return x;
+ }
+ 
+ static __inline u_short
+ itohs(u_short x)
+ {
+ #if BYTE_ORDER == LITTLE_ENDIAN
+ 	return x;
+ #else
+ 	return swap(x);
+ #endif
+ }
+ 
+ static __inline u_short
+ htois(u_short x)
+ {
+ #if BYTE_ORDER == LITTLE_ENDIAN
+ 	return x;
+ #else
+ 	return swap(x);
+ #endif
+ }
+ 
+ /*
+  * Given a physical address in the "hole",
+  * return a kernel virtual address.
+  */
+ #define	ISA_HOLE_VADDR(p)  ((caddr_t)p)
+ 
+ #endif
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/isareg.h
***************
*** 0 ****
--- 1,211 ----
+ /*	$NetBSD: isareg.h,v 1.4 1994/10/27 04:17:49 cgd Exp $	*/
+ 
+ /*-
+  * Copyright (c) 1990 The Regents of the University of California.
+  * All rights reserved.
+  *
+  * This code is derived from software contributed to Berkeley by
+  * William Jolitz.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *	This product includes software developed by the University of
+  *	California, Berkeley and its contributors.
+  * 4. Neither the name of the University nor the names of its contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  *	@(#)isa.h	5.7 (Berkeley) 5/9/91
+  */
+ 
+ /*
+  * ISA Bus conventions
+  */
+ 
+ #ifndef LOCORE
+ #include <sys/cdefs.h>
+ 
+ unsigned char rtcin __P((int));
+ void sysbeep __P((int, int));
+ unsigned kbd_8042cmd __P((int));
+ #endif /* !LOCORE */
+ 
+ 
+ /*
+  * Input / Output Port Assignments
+  */
+ 
+ #ifndef IO_BEGIN
+ #define	IO_ISABEGIN	0x000		/* 0x000 - Beginning of I/O Registers */
+ 
+ 		/* CPU Board */
+ #define	IO_DMA1		0x000		/* 8237A DMA Controller #1 */
+ #define	IO_ICU1		0x020		/* 8259A Interrupt Controller #1 */
+ #define	IO_PMP1		0x026		/* 82347 Power Management Peripheral */
+ #define	IO_TIMER1	0x040		/* 8253 Timer #1 */
+ #define	IO_TIMER2	0x048		/* 8253 Timer #2 (EISA only) */
+ #define	IO_KBD		0x060		/* 8042 Keyboard */
+ #define	IO_PPI		0x061		/* Programmable Peripheral Interface */
+ #define	IO_RTC		0x070		/* RTC */
+ #define	IO_NMI		IO_RTC		/* NMI Control */
+ #define	IO_DMAPG	0x080		/* DMA Page Registers */
+ #define	IO_ICU2		0x0A0		/* 8259A Interrupt Controller #2 */
+ #define	IO_DMA2		0x0C0		/* 8237A DMA Controller #2 */
+ #define	IO_NPX		0x0F0		/* Numeric Coprocessor */
+ 
+ 		/* Cards */
+ 					/* 0x100 - 0x16F Open */
+ 
+ #define	IO_WD2		0x170		/* Secondary Fixed Disk Controller */
+ #define	IO_PMP2		0x178		/* 82347 Power Management Peripheral */
+ 
+ 					/* 0x17A - 0x1EF Open */
+ 
+ #define	IO_WD1		0x1f0		/* Primary Fixed Disk Controller */
+ #define	IO_GAME		0x200		/* Game Controller */
+ 
+ 					/* 0x208 - 0x237 Open */
+ 
+ #define	IO_BMS2		0x238		/* secondary InPort Bus Mouse */
+ #define	IO_BMS1		0x23c		/* primary InPort Bus Mouse */
+ 
+ 					/* 0x240 - 0x277 Open */
+ 
+ #define	IO_LPT2		0x278		/* Parallel Port #2 */
+ 
+ 					/* 0x280 - 0x2E7 Open */
+ 
+ #define	IO_COM4		0x2e8		/* COM4 i/o address */
+ 
+ 					/* 0x2F0 - 0x2F7 Open */
+ 
+ #define	IO_COM2		0x2f8		/* COM2 i/o address */
+ 
+ 					/* 0x300 - 0x32F Open */
+ 
+ #define	IO_BT0		0x330		/* bustek 742a default addr. */
+ #define	IO_AHA0		0x330		/* adaptec 1542 default addr. */
+ #define	IO_UHA0		0x330		/* ultrastore 14f default addr. */
+ #define	IO_BT1          0x334		/* bustek 742a default addr. */
+ #define	IO_AHA1         0x334		/* adaptec 1542 default addr. */
+ 
+ 					/* 0x338 - 0x34F Open */
+ 
+ #define	IO_WDS		0x350		/* WD7000 scsi */
+ 
+ 					/* 0x354 - 0x36F Open */
+ 
+ #define	IO_FD2		0x370		/* secondary base i/o address */
+ #define	IO_LPT1		0x378		/* Parallel Port #1 */
+ 
+ 					/* 0x380 - 0x3AF Open */
+ 
+ #define	IO_MDA		0x3B0		/* Monochome Adapter */
+ #define	IO_LPT3		0x3BC		/* Monochome Adapter Printer Port */
+ #define	IO_VGA		0x3C0		/* E/VGA Ports */
+ #define	IO_CGA		0x3D0		/* CGA Ports */
+ 
+ 					/* 0x3E0 - 0x3E7 Open */
+ 
+ #define	IO_COM3		0x3e8		/* COM3 i/o address */
+ #define	IO_FD1		0x3f0		/* primary base i/o address */
+ #define	IO_COM1		0x3f8		/* COM1 i/o address */
+ 
+ #define	IO_ISAEND	0x3FF		/* - 0x3FF End of I/O Registers */
+ #endif /* !IO_ISABEGIN */
+ 
+ /*
+  * Input / Output Port Sizes - these are from several sources, and tend
+  * to be the larger of what was found, ie COM ports can be 4, but some
+  * boards do not fully decode the address, thus 8 ports are used.
+  */
+ 
+ #ifndef	IO_ISASIZES
+ #define	IO_ISASIZES
+ 
+ #define	IO_COMSIZE	8	/* 8250, 16X50 com controllers (*/
+ #define	IO_CGASIZE	16	/* CGA controllers */
+ #define	IO_DMASIZE	16	/* 8237 DMA controllers */
+ #define	IO_DPGSIZE	32	/* 74LS612 DMA page reisters */
+ #define	IO_FDCSIZE	8	/* Nec765 floppy controllers */
+ #define	IO_WDCSIZE	8	/* WD compatible disk controller */
+ #define	IO_GAMSIZE	16	/* AT compatible game controller */
+ #define	IO_ICUSIZE	16	/* 8259A interrupt controllers */
+ #define	IO_KBDSIZE	16	/* 8042 Keyboard controllers */
+ #define	IO_LPTSIZE	8	/* LPT controllers, some use onl */
+ #define	IO_MDASIZE	16	/* Monochrome display controller */
+ #define	IO_RTCSIZE	16	/* CMOS real time clock, NMI con */
+ #define	IO_TMRSIZE	16	/* 8253 programmable timers */
+ #define	IO_NPXSIZE	16	/* 80387/80487 NPX registers */
+ #define	IO_VGASIZE	16	/* VGA controllers */
+ #define	IO_PMPSIZE	2	/* 82347 Power Management Peripheral */
+ #endif /* !IO_ISASIZES */
+ 
+ /*
+  * Input / Output Memory Physical Addresses
+  */
+ 
+ #ifndef	IOM_BEGIN
+ #define	IOM_BEGIN	0x0a0000		/* Start of I/O Memory "hole" */
+ #define	IOM_END		0x100000		/* End of I/O Memory "hole" */
+ #define	IOM_SIZE	(IOM_END - IOM_BEGIN)
+ #endif /* !IOM_BEGIN */
+ 
+ /*
+  * RAM Physical Address Space (ignoring the above mentioned "hole")
+  */
+ 
+ #ifndef	RAM_BEGIN
+ #define	RAM_BEGIN	0x0000000	/* Start of RAM Memory */
+ #define	RAM_END		0x1000000	/* End of RAM Memory */
+ #define	RAM_SIZE	(RAM_END - RAM_BEGIN)
+ #endif /* !RAM_BEGIN */
+ 
+ /*
+  * Oddball Physical Memory Addresses
+  */
+ #ifndef	COMPAQ_RAMRELOC
+ #define	COMPAQ_RAMRELOC	0x80c00000	/* Compaq RAM relocation/diag */
+ #define	COMPAQ_RAMSETUP	0x80c00002	/* Compaq RAM setup */
+ #define	WEITEK_FPU	0xC0000000	/* WTL 2167 */
+ #define	CYRIX_EMC	0xC0000000	/* Cyrix EMC */
+ #endif /* !COMPAQ_RAMRELOC */
+ 
+ /* stuff that used to be in pccons.c */
+ #define	MONO_BASE	0x3B4
+ #define	MONO_BUF	(KERNBASE + 0xB0000)
+ #define	CGA_BASE	0x3D4
+ #define	CGA_BUF		(KERNBASE + 0xB8000)
+ #define	IOPHYSMEM	0xA0000
+ 
+ /*
+  * size of dma bounce buffer in pages
+  * - currently 1 page per channel
+  */
+ #ifndef DMA_BOUNCE
+ #define	DMA_BOUNCE      8
+ #endif
+ 
+ #ifndef LOCORE
+ extern vm_offset_t isaphysmem;
+ #endif /* !LOCORE */
*** old-NetBSD/src/sys/arch/amiga/stand/videomode/videomode.c
--- NetBSD/src/sys/arch/amiga/stand/videomode/videomode.c
***************
*** 1,6 ****
--- 1,7 ----
  /*	$NetBSD: videomode.c,v 1.3 1994/10/26 02:07:14 cgd Exp $	*/
  
  #include <sys/types.h>
+ #include <sys/device.h>
  #include <sys/stat.h>
  #include <sys/ioctl.h>
  #include "../../dev/grfioctl.h"
